import pytest
import edlib
from nerval import evaluate

fake_annot_original = "Gérard de Nerval was born in Paris in 1808 ."
fake_predict_original = "G*rard de *N*erval bo*rn in Paris in 1833 *."

expected_alignment = {
    'query_aligned': "Gérard de -N-erval was bo-rn in Paris in 1808 -.",
    'matched_aligned': '|.||||||||-|-||||||----||-|||||||||||||||||..|-|',
    'target_aligned': "G*rard de *N*erval ----bo*rn in Paris in 1833 *."}

@pytest.mark.parametrize("test_input, expected",
    [((fake_annot_original, fake_predict_original), expected_alignment)])
def test_align(test_input, expected) :
    a = edlib.align(*test_input, task="path")
    result_alignment = edlib.getNiceAlignment(a, *test_input)
    assert result_alignment == expected
