import pytest
from nerval import evaluate

fake_annot_entity_count = {'All': 3, 'DAT': 1, 'LOC': 1, 'PER': 1}
fake_predict_entity_count = {'All': 3, 'DAT': 1, '***': 1, 'PER': 1}
fake_matches = {'All': 1, 'PER': 1, 'LOC': 0, 'DAT': 0}

expected_scores = {
            '***': {'P': 0.0, 'R': None, 'F1': None},
            'DAT': {'P': 0.0, 'R': 0.0, 'F1': 0},
            'All': {'P': 0.3333333333333333, 'R': 0.3333333333333333, 'F1': 0.3333333333333333},
            'PER': {'P': 1.0, 'R': 1.0, 'F1': 1.0},
            'LOC': {'P': None, 'R': 0.0, 'F1': None}
            }


@pytest.mark.parametrize("test_input, expected",
    [((fake_annot_entity_count, fake_predict_entity_count, fake_matches), expected_scores)]
)
def test_compute_scores(test_input, expected) :
    assert evaluate.compute_scores(*test_input) == expected
